"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const initialiseHandler_1 = require("./src/initialiseHandler");
class ExpressWrapper {
    constructor(data) {
        /* Mongo client is required for using a request limiter */
        initialiseHandler_1.validateWrapperData(data);
        this.wrapperData = data;
    }
    /**
     * Intialise all endpoints and begin express listener
     */
    initialise() {
        return __awaiter(this, void 0, void 0, function* () {
            return initialiseHandler_1.initialiseEndpoints(this.wrapperData);
        });
    }
    /**
     * Get endpoint names
     * @returns array of all endpoint names
     */
    getEndpointList() {
        return this.wrapperData.endpoints.map((x) => x.name);
    }
    /**
     * Get endpoint data
     * @returns array of endpoint structures
     */
    getEndpointData() {
        return this.wrapperData.endpoints;
    }
}
exports.default = ExpressWrapper;
